/**
 * ******************************************************************************
 *  Copyright Fujitsu.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  You may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * *****************************************************************************
 *
 *  NIFCLOUD SDK for Java
 *
 */
package com.nifty.cloud.sdk.autoscale.model.transform;

import java.util.ArrayList;
import java.util.List;

import com.nifty.cloud.sdk.autoscale.model.LogSet;
import com.nifty.cloud.sdk.autoscale.model.ScallingLogDetails;
import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

/**
 * LogSet変換クラス。<br />
 * このクラスはレスポンスXMLのlogSetの要素からLogSetクラスを生成します。
 */
public class LogSetConverter implements Converter {

    private static final String ELEMENT_TIME = "time";
    private static final String ELEMENT_PROCESS = "process";
    private static final String ELEMENT_RESOURCE = "resource";
    private static final String ELEMENT_UPPER_THRESHOLD = "upperThreshold";
    private static final String ELEMENT_CURRENT_SERVERS_COUNT = "currentServersCount";
    private static final String ELEMENT_CHANGE_IN_CAPACITY = "changeInCapacity";
    private static final String ELEMENT_RESOURCE_VALUE = "resourceValue";

    private static final String ELEMENT_DETAILS = "details";
    private static final String ITEM = "item";

    /**
     * 変換可能なクラスか判定します。
     *
     * @param type
     *            クラス
     * @return 変換可能な場合true, 変換不可能な場合false
     *
     * @see com.thoughtworks.xstream.converters.Converter#canConvert(Class)
     */
    @Override
    @SuppressWarnings("rawtypes")
    public boolean canConvert(Class type) {
        return type == LogSet.class;
    }

    @Override
    public void marshal(Object source, HierarchicalStreamWriter writer,
        MarshallingContext context) {
        // 処理無し
    }

    @Override
    public Object unmarshal(HierarchicalStreamReader reader, UnmarshallingContext context) {

        List<LogSet> list = new ArrayList<LogSet>();

        LogSet logSet = null;
        ScallingLogDetails details = null;

        String name = null;

        while (reader.hasMoreChildren()) {

            logSet = new LogSet();
            details = new ScallingLogDetails();

            reader.moveDown();

            name = reader.getNodeName();

            if (name.equals(ITEM)) {

                while (reader.hasMoreChildren()) {

                    reader.moveDown();

                    name = reader.getNodeName();

                    if (name.equals(ELEMENT_TIME)) {
                        logSet.setTime(reader.getValue());
                    } else if (name.equals(ELEMENT_PROCESS)) {
                        logSet.setProcess(reader.getValue());
                    } else if (name.equals(ELEMENT_DETAILS)) {

                        while (reader.hasMoreChildren()) {

                            reader.moveDown();

                            name = reader.getNodeName();

                            if (name.equals(ELEMENT_RESOURCE)) {
                                details.setResource(reader.getValue());
                            } else if (name.equals(ELEMENT_UPPER_THRESHOLD)) {
                                details.setUpperThreshold(Double.parseDouble(reader.getValue()));
                            } else if (name.equals(ELEMENT_CURRENT_SERVERS_COUNT)) {
                                details.setCurrentServersCount(Integer.parseInt(reader.getValue()));
                            } else if (name.equals(ELEMENT_CHANGE_IN_CAPACITY)) {
                                details.setChangeInCapacity(Integer.parseInt(reader.getValue()));
                            }else if (name.equals(ELEMENT_RESOURCE_VALUE)) {
                                details.setResourceValue(Integer.parseInt(reader.getValue()));
                            }

                            reader.moveUp();

                        }

                    }

                    reader.moveUp();

                }

            }

            logSet.setDetails(details);

            list.add(logSet);

            reader.moveUp();

        }

        return list;
    }

}
